#include <windows.h>
#include <shlobj.h>
#include "registry.h"
#include "subroutine.h"
#include "ttf.h" // array of TrueType fonts name.


BOOL IsInstalledWinTeX( void );
BOOL IsInstalledWinTeXAmS( void );
BOOL IsInstalledBaKoMa( void );
void UninstallBaKoMa( void );
void UninstallWinTeX( void );
void UninstallWinTeXAmS( void );
void InstallBaKoMa( void );

static BOOL GetFontFolder( char* folder );
static void AddFont( const char* ttf_folder, const char* ttf_name );
void RegistTrueTypeFonts( const char* ttf_folder );

int __stdcall WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd )
{
	if( IsWindowsNT() )
	{
		REG* rp;
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts" );
		if( rp == NULL )
		{
			MessageBox( NULL, "̃\tg̎sɂ͊ǗҌKvłB",
				"pLaTeX2e for Win SP1", MB_OK | MB_ICONSTOP );
			return 1;
		}
		rclose( rp );
	}

	if( IsInstalledWinTeX() == TRUE )
	{
		int r = MessageBox( NULL, "̃VXeɂ́ACvXЂ\n"
					"TeX for WindowspComputer ModerntHg\n"
					"CXg[Ă܂B\n"
					"BaKoMatHg𗘗p邽߂ɂ́A\n"
					"tHgACXg[Kv܂B\n"
					"ȂÃtHgACXg[ƁA\n"
					"CvXЂWinDvigp邱Ƃ͂łȂȂ܂B\n"
					"Ȃ́ABaKoMatHgCXg[ɁA\n"
					"DVIOUTɂWinTeXtHg𗘗p悤\n"
					"ݒ肷邱Ƃł܂B\n"
					"DVIOUT̐ݒύX邩AWinTeXtHgACXg[\n"
					"Ȃ΁ADVIOUT͐삷邱Ƃł܂B\n"
					"WinTeXtHgACXg[܂B",
					"pLaTeX2e for Win SP1", MB_YESNO | MB_ICONQUESTION | MB_TOPMOST );
		if( r == IDYES )
		{
			UninstallWinTeX();
			UninstallWinTeXAmS();
		}
		else
		{
			MessageBox( NULL, "WinTeXtHg̃ACXg[͍s܂łB\n"
				"DVIOUT̃vpeB[V[gAmWinJFontny[WɂāA\n"
				"mjfm(omit pt)/tfmn̍ŁmedefaultnIA\n"
				"mTrueType Fontnmcmr10niftHgjIA\n"
				"mJapanese TTñ`FbNOA\n"
				"mcode typenŁmWinTeXnIA\n"
				"mDefinenĂ̐ݒ`A\n"
				"mSaven{^TrueTypetHg̐ݒύXĂB\n"
				"̐ݒsȂ΁ADVIOUT̕\sȂ̂ƂȂ܂B\n"
				"̃bZ[W{bNXOɁAL̓eĂƂ\n"
				"܂B",
				"pLaTeX2e for Win SP1", MB_OK | MB_TOPMOST );
			return 1;
		}
	}

	if( IsInstalledBaKoMa() == FALSE )
	{
		int r = MessageBox( NULL, "BaKoMa TrueType Fonts̓CXg[Ă܂B\n"
						"BaKoMa tHgCXg[܂H",
						"pLaTeX2e for Win SP1", MB_YESNO | MB_ICONQUESTION | MB_TOPMOST );
		if( r == IDYES ) // User want to install BaKoMa.
		{
			InstallBaKoMa();
			MessageBox( NULL, "I܂B", "pLaTeX2e for Win SP1", MB_OK | MB_TOPMOST );
		}
		else // User doesn't want to install BaKoMa.
		{
			MessageBox( NULL, "I܂B", "pLaTeX2e for Win SP1", MB_OK | MB_TOPMOST );
		}
	}
	else
	{
		UninstallBaKoMa();
		InstallBaKoMa();
		MessageBox( NULL, "I܂B", "pLaTeX2e for Win SP1", MB_OK | MB_TOPMOST );
	}
	return 0;
}

BOOL IsInstalledWinTeX( void )
{
	char font_path[MAX_PATH];
	if ( GetFontFolder(font_path) == FALSE ) return FALSE;
	REG* rp;
	if( IsWindowsNT() )
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts", "r" );
	else
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Fonts", "r");
	if( rp == NULL ) return FALSE;
	char check_name[128];
	wsprintf( check_name, "%s Regular (TrueType)", WinTeX0[0] );
	char ttf_filename[MAX_PATH];
	const char* val = rgets( ttf_filename, MAX_PATH, rp, check_name );
	rclose( rp );
	if( val == NULL ) return FALSE;
	else return TRUE;
}

BOOL IsInstalledWinTeXAmS( void )
{
	char font_path[MAX_PATH];
	if ( GetFontFolder(font_path) == FALSE ) return FALSE;
	REG* rp;
	if( IsWindowsNT() )
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts", "r" );
	else
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Fonts", "r" );
	if( rp == NULL ) return FALSE;
	char check_name[128];
	wsprintf( check_name, "%s Regular (TrueType)", WinTeX1[67] );
	char ttf_filename[MAX_PATH];
	const char* val = rgets( ttf_filename, MAX_PATH, rp, check_name );
	rclose( rp );
	if( val == NULL ) return FALSE;
	else return TRUE;
}

BOOL IsInstalledBaKoMa( void )
{
	char font_path[MAX_PATH];
	if ( GetFontFolder(font_path) == FALSE ) return FALSE;
	REG* rp;
	if( IsWindowsNT() )
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts", "r" );
	else
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Fonts", "r" );
	if( rp == NULL ) return FALSE;
	char check_name[128];
	wsprintf( check_name, "%s (TrueType)", BaKoMa[87] );
	char ttf_filename[MAX_PATH];
	const char* val = rgets( ttf_filename, MAX_PATH, rp, check_name );
	rclose( rp );
	if( val == NULL ) return FALSE;
	else return TRUE;
}

void UninstallBaKoMa( void )
{
	if( IsInstalledBaKoMa() == FALSE ) return;
	char ttf_folder[MAX_PATH];
	if ( GetFontFolder(ttf_folder) == FALSE ) return;
	REG* rp;
	if( IsWindowsNT() )
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts" );
	else
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Fonts" );
	if( rp == NULL ) return;

	for( int i = 0; i <= 139; i++ )
	{
		char reg_ttf_name[MAX_PATH];
		wsprintf( reg_ttf_name, "%s (TrueType)", BaKoMa[i] );
		char ttf_filename[MAX_PATH];
		if( rgets(ttf_filename, MAX_PATH, rp, reg_ttf_name) == NULL ) continue;
		rdelete_value( rp, reg_ttf_name );
		RemoveFontResource( reg_ttf_name );
		if( FindFirstChar(ttf_filename, '\\') == -1 )
		{ // ttf_filename doesn't include '\'
			if( FindFirstChar(ttf_filename, '.') == -1 ) lstrcat( ttf_filename, ".ttf" );
			int l = lstrlen( ttf_folder );
			if( l == 0 ) continue;
			char ttfname[MAX_PATH];
			if( ttf_folder[l-1] == '\\' )
				wsprintf( ttfname, "%s%s", ttf_folder, ttf_filename );
			else
				wsprintf( ttfname, "%s\\%s", ttf_folder, ttf_filename );
			SetFileAttributes( ttfname, FILE_ATTRIBUTE_NORMAL );
			DeleteFile( ttfname );
		}
		SendMessage( HWND_BROADCAST, WM_FONTCHANGE, 0, 0 );
	}
	rclose( rp );
	return;
}

void UninstallWinTeX( void )
{
	if( IsInstalledWinTeX() == FALSE ) return;
	char ttf_folder[MAX_PATH];
	if ( GetFontFolder(ttf_folder) == FALSE ) return;
	REG* rp;
	if( IsWindowsNT() )
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts" );
	else
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Fonts" );
	if( rp == NULL ) return;

	for( int i = 0; i <= 64; i++ )
	{
		char reg_ttf_name[MAX_PATH];
		wsprintf( reg_ttf_name, "%s Regular (TrueType)", WinTeX0[i] );
		char ttf_filename[MAX_PATH];
		if( rgets(ttf_filename, MAX_PATH, rp, reg_ttf_name) == NULL ) continue;
		rdelete_value( rp, reg_ttf_name );
		RemoveFontResource( reg_ttf_name );
		if( FindFirstChar(ttf_filename, '\\') == -1 )
		{ // ttf_filename doesn't include '\'
			if( FindFirstChar(ttf_filename, '.') == -1 ) lstrcat( ttf_filename, ".ttf" );
			int l = lstrlen( ttf_folder );
			if( l == 0 ) continue;
			char ttfname[MAX_PATH];
			if( ttf_folder[l-1] == '\\' )
				wsprintf( ttfname, "%s%s", ttf_folder, ttf_filename );
			else
				wsprintf( ttfname, "%s\\%s", ttf_folder, ttf_filename );
			SetFileAttributes( ttfname, FILE_ATTRIBUTE_NORMAL );
			DeleteFile( ttfname );
		}
		SendMessage( HWND_BROADCAST, WM_FONTCHANGE, 0, 0 );
	}
	rclose( rp );
	return;
}

void UninstallWinTeXAmS( void )
{
	if( IsInstalledWinTeXAmS() == FALSE ) return;
	char ttf_folder[MAX_PATH];
	if ( GetFontFolder(ttf_folder) == FALSE ) return;
	REG* rp;
	if( IsWindowsNT() )
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts" );
	else
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Fonts" );
	if( rp == NULL ) return;

	for( int i = 0; i <= 88; i++ )
	{
		char reg_ttf_name[MAX_PATH];
		wsprintf( reg_ttf_name, "%s Regular (TrueType)", WinTeX1[i] );
		char ttf_filename[MAX_PATH];
		if( rgets(ttf_filename, MAX_PATH, rp, reg_ttf_name) == NULL ) continue;
		rdelete_value( rp, reg_ttf_name );
		RemoveFontResource( reg_ttf_name );
		if( FindFirstChar(ttf_filename, '\\') == -1 )
		{ // ttf_filename doesn't include '\'
			if( FindFirstChar(ttf_filename, '.') == -1 ) lstrcat( ttf_filename, ".ttf" );
			int l = lstrlen( ttf_folder );
			if( l == 0 ) continue;
			char ttfname[MAX_PATH];
			if( ttf_folder[l-1] == '\\' )
				wsprintf( ttfname, "%s%s", ttf_folder, ttf_filename );
			else
				wsprintf( ttfname, "%s\\%s", ttf_folder, ttf_filename );
			SetFileAttributes( ttfname, FILE_ATTRIBUTE_NORMAL );
			DeleteFile( ttfname );
		}
		SendMessage( HWND_BROADCAST, WM_FONTCHANGE, 0, 0 );
	}
	rclose( rp );
	return;
}

void InstallBaKoMa( void )
{
	char ttf_dir[MAX_PATH];
	ttf_dir[0] = NULL;
	
	char drive_name[4];
	wsprintf( drive_name, "a:\\" );
search_cd:;
	for( char c = 'z'; c >= 'a'; c-- )
	{
		drive_name[0] = c;
		if( GetDriveType(drive_name) == 1 ) continue;
		HANDLE hFind;
		WIN32_FIND_DATA ffd;
		char search_file[MAX_PATH];
		wsprintf( search_file, "%sCM-TrueType", drive_name );
		hFind = FindFirstFile( search_file, &ffd );
		if( hFind == INVALID_HANDLE_VALUE )
			continue;
		else
		{
			FindClose( hFind );
			wsprintf( ttf_dir, "%sCM-TrueType", drive_name );
			break;
		}
	}
	if( ttf_dir[0] == NULL )
	{
		int r = MessageBox( NULL, "pLaTeX2e for Windows Another Manual Vol.1 BasicKit 1999\n"
					"CD-ROM}ĂB", "pLaTeX2e for Win SP1",
					MB_OKCANCEL );
		if( r == IDCANCEL ) return;
		goto search_cd;
	}
	RegistTrueTypeFonts( ttf_dir );
	return;
}

static BOOL GetFontFolder( char* folder )
{
	LPITEMIDLIST ppidl; // PIDL (Pointer to ID List)
	HRESULT hr;

	hr = SHGetSpecialFolderLocation( NULL, CSIDL_FONTS, &ppidl );
	if( FAILED(hr) ) return FALSE;
	return SHGetPathFromIDList( ppidl, folder );
}

void RegistTrueTypeFonts( const char* ttf_folder )
{
	char ttfname[MAX_PATH];

	int l = lstrlen( ttf_folder );
	if( l == 0 ) return;
	if( ttf_folder[l-1] == '\\' )
		wsprintf( ttfname, "%s*.ttf", ttf_folder );
	else
		wsprintf( ttfname, "%s\\*.ttf", ttf_folder );
	
	WIN32_FIND_DATA ffd; 
	HANDLE hFind = FindFirstFile( ttfname, &ffd );
	if( hFind == INVALID_HANDLE_VALUE ) return;
	do
	{
		AddFont( ttf_folder, ffd.cFileName );
	} while( FindNextFile(hFind,&ffd) != FALSE );
	FindClose( hFind );
}

static void AddFont( const char* ttf_folder, const char* ttf_name )
{
	int len = lstrlen(ttf_folder) + lstrlen(ttf_name) + 2;
	
	char* ttf_fullpath = (char*)malloc( len*sizeof(char) );

	int l = lstrlen( ttf_folder );
	if( l == 0 ) return;
	if( ttf_folder[l-1] == '\\' )
		wsprintf( ttf_fullpath, "%s%s", ttf_folder, ttf_name );
	else
		wsprintf( ttf_fullpath, "%s\\%s", ttf_folder, ttf_name );

	// Copying TrueType Fonts to the system font directory. 
	char font_folder[MAX_PATH];
	if( GetFontFolder(font_folder) == FALSE ) return;
	lstrcat( font_folder, "\\" );
	lstrcat( font_folder, ttf_name );
	if( CopyFile(ttf_fullpath, font_folder, TRUE) == FALSE ) return;

	// regist ttf in the system font directory.
	int r = AddFontResource( font_folder );
	REG* rp;
	if( IsWindowsNT() )
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows NT\\CurrentVersion\\Fonts" );
	else
		rp = ropen( HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Windows\\CurrentVersion\\Fonts" );
	// Creating fonts name.
	char font_reg_key[128];
	char font_reg_node[128];
	lstrcpy( font_reg_node, ttf_name );
	int p = FindLastChar( font_reg_node, '.' );
	if( p != 0 )
	{
		font_reg_node[p] = NULL;
	}
	wsprintf( font_reg_key, "%s (TrueType)", font_reg_node );
	lstrcat( font_reg_node, ".ttf" );

	if( r != 0 )
	{
		rputs( font_reg_node, rp, font_reg_key );
		SendMessage( HWND_BROADCAST, WM_FONTCHANGE, 0, 0 );
	}
	rclose( rp );
	free( ttf_fullpath );
	return;
}

