#include <windows.h>
#include "subroutine.h"

BOOL IsWindowsNT( void )
{
    OSVERSIONINFO osversion;
    memset( &osversion, 0, sizeof(OSVERSIONINFO) );
    osversion.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&osversion);
    if( osversion.dwPlatformId == VER_PLATFORM_WIN32_NT )
    {
        return TRUE;
    }
    return FALSE;
}

int FindLastChar( const char* str, char c )
{
	/* This function checks whether the char c exists in the str.
	   If c exists, this function returns the LAST index of c.
	   If not exists, return -1; */
	int ret = -1;
	BOOL prev_is_kanji1 = FALSE;
	int l = lstrlen( str );
	for( int i = 0; i < l; i ++ )
	{
		if( prev_is_kanji1 == TRUE )
		{// we must skip the 2nd byte of Shift-JIS.
		 // the next character of 2nd byte of Shift-JIS is always not a 2nd byte of Kanji.
			prev_is_kanji1 = FALSE;
			continue;
		}
		else // prev_is_kanji == FALSE
		{// the previous character is not Shift-JIS first code. 
			if( str[i] == c )
			{
				ret = i;
				continue;
			}
			else if( IsKanji1(str[i]) == TRUE )
			{
				prev_is_kanji1 = TRUE;
				continue;
			}
			else
				continue;
		}
	}
	return ret;
}

int FindFirstChar( const char* str, char c )
{
	/* This function checks whether the char c exists in the str.
	   If c exists, this function returns the FIRST index of c.
	   If not exists, return -1; */
	BOOL prev_is_kanji1 = FALSE;
	int l = lstrlen( str );
	for( int i = 0; i < l; i ++ )
	{
		if( prev_is_kanji1 == TRUE )
		{// we must skip the 2nd byte of Shift-JIS.
		 // the next character of 2nd byte of Shift-JIS is always not a 2nd byte of Kanji.
			prev_is_kanji1 = FALSE;
			continue;
		}
		else // prev_is_kanji == FALSE
		{// the previous character is not Shift-JIS first code. 
			if( str[i] == c )
			{
				return i;
				continue;
			}
			else if( IsKanji1(str[i]) == TRUE )
			{
				prev_is_kanji1 = TRUE;
				continue;
			}
			else
				continue;
		}
	}
	return -1;
}

BOOL IsKanji1( const unsigned char c )
{
	if( (c >= 0x81 && c <= 0x9F) || (c >= 0xE0 && c <= 0xFC) )
		return TRUE;
	else
		return FALSE;
}
